 // Vyp1View.cpp : implementation file
//

#include "stdafx.h"
#include "kodpol.h"  ////nutne pro Cvykazy1Doc
#include "vykazy1Doc.h"
#include "vykazy1.h"
#include "Poldialog.h"
#include "Vyp1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define NUM_COLUMNS	3

static _TCHAR *_gszColumnLabel[NUM_COLUMNS] =
{
	_T("Kd"), _T("Poet vkon"), _T("Cena Prce")
};

static int _gnColumnFmt[NUM_COLUMNS] = 
{
	LVCFMT_LEFT,LVCFMT_LEFT,LVCFMT_LEFT
};

static int _gnColumnWidth[NUM_COLUMNS] = 
{
	0, 0, 0
};

/////////////////////////////////////////////////////////////////////////////
// CVyp1View

IMPLEMENT_DYNCREATE(CVyp1View, CListView)

CVyp1View::CVyp1View()
{
	m_clrBkgnd = ::GetSysColor(COLOR_WINDOW);
	m_clrTextBk = ::GetSysColor(COLOR_WINDOW);
}


CVyp1View::~CVyp1View()
{
}


BEGIN_MESSAGE_MAP(CVyp1View, CListView)
	//{{AFX_MSG_MAP(CVyp1View)
	ON_WM_LBUTTONDBLCLK()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVyp1View drawing

// offsets for first and other columns
#define OFFSET_FIRST	2
#define OFFSET_OTHER	6

void CVyp1View::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

//vol se pi vykreslovn jedn poloky, pokud je 
// v precreatewindow nastaveno LVS_OWNERDRAWFIXED!! 
void CVyp1View::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CListCtrl& ListCtrl=GetListCtrl();
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	CRect rcItem(lpDrawItemStruct->rcItem);
	int nItem = lpDrawItemStruct->itemID;
	BOOL bFocus = (GetFocus() == this);
	COLORREF clrTextSave, clrBkSave;
	COLORREF clrImage = m_clrBkgnd;
	static _TCHAR szBuff[MAX_PATH];
	LPCTSTR pszText;

// get item data

	LV_ITEM lvi;
	lvi.mask = LVIF_TEXT | LVIF_STATE;
	lvi.iItem = nItem;
	lvi.iSubItem = 0;
	lvi.pszText = szBuff;
	lvi.cchTextMax = sizeof(szBuff);
	lvi.stateMask = 0xFFFF;		// get all state flags
	ListCtrl.GetItem(&lvi);

	BOOL bSelected = (bFocus || (GetStyle() & LVS_SHOWSELALWAYS)) && lvi.state & LVIS_SELECTED;
	bSelected = bSelected || (lvi.state & LVIS_DROPHILITED);

// set colors if item is selected

	CRect rcAllLabels;
	ListCtrl.GetItemRect(nItem, rcAllLabels, LVIR_BOUNDS);

	CRect rcLabel;
	ListCtrl.GetItemRect(nItem, rcLabel, LVIR_LABEL);

//   if (rcAllLabels.right<m_cxClient)
//		rcAllLabels.right = m_cxClient;

	rcAllLabels.left = rcLabel.left;
	
	if (bSelected)
	{
		clrTextSave = pDC->SetTextColor(::GetSysColor(COLOR_HIGHLIGHTTEXT));
		clrBkSave = pDC->SetBkColor(::GetSysColor(COLOR_HIGHLIGHT));

		pDC->FillRect(rcAllLabels, &CBrush(::GetSysColor(COLOR_HIGHLIGHT)));
	}
	else
		pDC->FillRect(rcAllLabels, &CBrush(m_clrTextBk));

// draw item label

	ListCtrl.GetItemRect(nItem, rcItem, LVIR_LABEL);

	pszText = MakeShortString(pDC, szBuff,
				rcItem.right-rcItem.left, 2*OFFSET_FIRST);

	rcLabel = rcItem;
	rcLabel.left += OFFSET_FIRST;
	rcLabel.right -= OFFSET_FIRST;

	pDC->DrawText(pszText,-1,rcLabel,DT_LEFT | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);

// draw labels for extra columns

	LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH;
				   
	for(int nColumn = 1; ListCtrl.GetColumn(nColumn, &lvc); nColumn++)
	{
		rcItem.left = rcItem.right;
		rcItem.right += lvc.cx;

		int nRetLen = ListCtrl.GetItemText(nItem, nColumn,
						szBuff, sizeof(szBuff));
		if (nRetLen == 0)
			continue;

		pszText = MakeShortString(pDC, szBuff,
			rcItem.right - rcItem.left, 2*OFFSET_OTHER);

		UINT nJustify = DT_LEFT;

		if(pszText == szBuff)
		{
			switch(lvc.fmt & LVCFMT_JUSTIFYMASK)
			{
			case LVCFMT_RIGHT:
				nJustify = DT_RIGHT;
				break;
			case LVCFMT_CENTER:
				nJustify = DT_CENTER;
				break;
			default:
				break;
			}
		}

		rcLabel = rcItem;
		rcLabel.left += OFFSET_OTHER;
		rcLabel.right -= OFFSET_OTHER;

		pDC->DrawText(pszText, -1, rcLabel,
			nJustify | DT_SINGLELINE | DT_NOPREFIX | DT_NOCLIP | DT_VCENTER);
	}

// draw focus rectangle if item has focus

	if (lvi.state & LVIS_FOCUSED && bFocus)
		pDC->DrawFocusRect(rcAllLabels);

// set original colors if item was selected

	if (bSelected)
	{
        pDC->SetTextColor(clrTextSave);
		pDC->SetBkColor(clrBkSave);
	}
}


LPCTSTR CVyp1View::MakeShortString(CDC* pDC, LPCTSTR lpszLong, int nColumnLen, int nOffset)
{
	static const _TCHAR szThreeDots[] = _T("...");

	int nStringLen = lstrlen(lpszLong);

	if(nStringLen == 0 ||
		(pDC->GetTextExtent(lpszLong, nStringLen).cx + nOffset) <= nColumnLen)
	{
		return(lpszLong);
	}

	static _TCHAR szShort[MAX_PATH];

	lstrcpy(szShort,lpszLong);
	int nAddLen = pDC->GetTextExtent(szThreeDots,sizeof(szThreeDots)).cx;

	for(int i = nStringLen-1; i > 0; i--)
	{
		szShort[i] = 0;
		if((pDC->GetTextExtent(szShort, i).cx + nOffset + nAddLen)
			<= nColumnLen)
		{
			break;
		}
	}

	lstrcat(szShort, szThreeDots);
	return(szShort);
}

/////////////////////////////////////////////////////////////////////////////
// CVyp1View diagnostics

#ifdef _DEBUG
void CVyp1View::AssertValid() const
{
	CListView::AssertValid();
}

void CVyp1View::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG


CVykazy1Doc* CVyp1View::GetDocument()
{
 return (CVykazy1Doc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CVyp1View message handlers

void CVyp1View::OnInitialUpdate() 
{
	int i;

	CListView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
    // insert columns
	//dostane ukazatel na list control
	CListCtrl& ListCtrl = GetListCtrl();
	CVykazy1Doc* pDoc=GetDocument();

    ListCtrl.DeleteAllItems();
    LV_COLUMN lvc;
	lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
     // insert columns
	for(i = 0; i<NUM_COLUMNS; i++)
	{
	    int a;
		lvc.iSubItem = i;
		lvc.pszText = _gszColumnLabel[i];
		lvc.cx = _gnColumnWidth[i];
		lvc.fmt = _gnColumnFmt[i];
		a=ListCtrl.InsertColumn(i,&lvc);
	}

    // insert items
	LV_ITEM lvi;
	Ckodpol* ppol;
	char pomstr[256];
	for(i = 0; i < pDoc->m_zarazkaST; i++)
	{
		ppol=pDoc->poleST[i];
		sprintf(pomstr,"%d",ppol->dejkod());
		lvi.mask = LVIF_TEXT;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText =pomstr;
		ListCtrl.InsertItem(&lvi);
	}

  // set item text for additional columns
  float cenaprac;
  int j;
  for(i = 0; i<pDoc->m_zarazkaST; i++)
	{
     ppol=pDoc->poleST[i];
	 j=1;
  	 sprintf(pomstr,"%d",ppol->dejpocetInt());
	 ListCtrl.SetItemText(i,j,pomstr);
	 j++;
     cenaprac=ppol->pocetInt*ppol->cena;
	 sprintf(pomstr,"%8.2f",cenaprac);
	 ListCtrl.SetItemText(i,j,pomstr);
	}
}

BOOL CVyp1View::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	//velmi nutn!!!!!
	cs.style &= ~LVS_TYPEMASK;
	cs.style |= LVS_REPORT | LVS_OWNERDRAWFIXED | LVS_SHOWSELALWAYS;
	return CListView::PreCreateWindow(cs);
}


void CVyp1View::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default

   CListCtrl& ListCtrl = GetListCtrl();
   CVykazy1Doc* pDoc=GetDocument();
   char pomstr[256];
   
   //najde oznacenou polozku
   int nItem = ListCtrl.GetNextItem(-1, LVNI_FOCUSED);
   /*
   sprintf(pom,"item num %d",nItem);
   AfxMessageBox( pom,MB_OK|MB_ICONSTOP,0 );
   */
   if ( nItem<0 )  return;
   Ckodpol* ppol=pDoc->poleST[nItem];
   CPoldialog dlg;
   dlg.LoaddatSTPRkode(ppol);
   if (dlg.DoModal()==IDCANCEL) return;
   //updatuje hodnoty z dialogu do polozky v dokumentu 
   dlg.SavedatSTPRkode(ppol);

   //updatuje radek v tabulce
   sprintf(pomstr,"%d",ppol->dejpocetInt());
   ListCtrl.SetItemText(nItem,1,pomstr);
   float cenaprac=ppol->pocetInt*ppol->cena;
   sprintf(pomstr,"%8.2f",cenaprac);
   ListCtrl.SetItemText(nItem,2,pomstr);

   pDoc->SetModifiedFlag();
   pDoc->defchanged(true);  
   CListView::OnLButtonDblClk(nFlags, point);
}

void CVyp1View::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
   // TODO: Add your specialized code here and/or call the base class
   //obnovy vypis view
   // smazanim a opetovnym vypisem vsech polozek 
   CListCtrl& ListCtrl = GetListCtrl();
   ListCtrl.DeleteAllItems();
   CVykazy1Doc* pDoc=GetDocument();
   // insert items
    LV_ITEM lvi;
	Ckodpol* ppol2;
	char pomstr[256];
	for(int i = 0; i < pDoc->m_zarazkaST; i++)
	{
		ppol2=pDoc->poleST[i];
		sprintf(pomstr,"%d",ppol2->dejkod());
		lvi.mask = LVIF_TEXT;
		lvi.iItem = i;
		lvi.iSubItem = 0;
		lvi.pszText =pomstr;
		ListCtrl.InsertItem(&lvi);
	}

  // set item text for additional columns
  float cenaprac;
  int j;
  for(i = 0; i<pDoc->m_zarazkaST; i++)
	{
     ppol2=pDoc->poleST[i];
	 j=1;
  	 sprintf(pomstr,"%d",ppol2->dejpocetInt());
	 ListCtrl.SetItemText(i,j,pomstr);
	 j++;
     cenaprac=ppol2->pocetInt*ppol2->cena;
	 sprintf(pomstr,"%8.2f",cenaprac);
	 ListCtrl.SetItemText(i,j,pomstr);
	}
}

void CVyp1View::OnSize(UINT nType, int cx, int cy) 
{
	CListView::OnSize(nType, cx, cy);
	int i;
	// TODO: Add your message handler code here
    // prekresli kolonky v tabulce, zmeni jejich siri
	CListCtrl& ListCtrl = GetListCtrl();
    CRect mainRect;
	GetClientRect(mainRect);
	//calculate colums width
	int colwidth=(mainRect.Width()/3);

	for(i=0;i<NUM_COLUMNS;i++){
      _gnColumnWidth[i]=colwidth;
	}
	
    // change columns width
	for(i = 0; i<NUM_COLUMNS; i++)
	{
	  ListCtrl.SetColumnWidth(i,_gnColumnWidth[i]);
	}
}


void CVyp1View::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
    CListCtrl& ListCtrl = GetListCtrl();
    CVykazy1Doc* pDoc=GetDocument();
   	char pomstr[256];
	int retcode;
	
    //check if delelete key is pressed
    if (nChar==46 && nFlags==339) {
     //najde oznacenou polozku
     int nItem = ListCtrl.GetNextItem(-1, LVNI_FOCUSED);
     if ( nItem<0 )  return;
     Ckodpol* ppol=pDoc->poleST[nItem];
     sprintf(pomstr,"Chcete vymazat poloku s kdem %d ?",ppol->dejkod());
	 retcode=AfxMessageBox(pomstr,MB_OKCANCEL|MB_ICONSTOP,0);
	 if (retcode==IDOK) {
		 //je na konci
      	if (nItem==(int)(pDoc->m_zarazkaST)){
		 delete pDoc->poleST[nItem];
         pDoc->UpdateAllViews(NULL);
	     if (pDoc->m_zarazkaST>1) pDoc->setridST(0,pDoc->m_zarazkaST-1);
	     pDoc->defchanged(true); //change in definition code removed
		}
		//neni na konci
		else{
		 delete pDoc->poleST[nItem]; 
		 for (int i=nItem;i<(int)(pDoc->m_zarazkaST-1);i++){
			 pDoc->poleST[i]=pDoc->poleST[i+1];
		 }
		 pDoc->m_zarazkaST--;
	     pDoc->UpdateAllViews(NULL);
	 	 if (pDoc->m_zarazkaST>1) pDoc->setridST(0,pDoc->m_zarazkaST-1);
	     pDoc->defchanged(true); //change in definition code removed
		}
		pDoc->SetModifiedFlag();
	 }
	}
    CListView::OnKeyDown(nChar, nRepCnt, nFlags);
}
