// Vyp4View.cpp : implementation file
//

#include "stdafx.h"
#include "vykazy1.h"
#include "kodpol.h"
#include "Vykazy1Doc.h"
#include "Vyp4View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVyp4View

IMPLEMENT_DYNCREATE(CVyp4View, CScrollView)

CVyp4View::CVyp4View()
{
}

CVyp4View::~CVyp4View()
{
}


BEGIN_MESSAGE_MAP(CVyp4View, CScrollView)
	//{{AFX_MSG_MAP(CVyp4View)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVyp4View drawing

void CVyp4View::OnDraw(CDC* pDC)
{
    CVykazy1Doc* pDoc=GetDocument();

	// The window has been invalidated and needs to be repainted;
	// or a page needs to be printed (or previewed).
	// First, determine the range of rows that need to be displayed or
	// printed.

	int y,i,ycount=0;
	int cntST,cntPR,cntOST;
	cntST=cntPR=cntOST=0;
	float ccenaST,ccenaPR,ccenaOST;
	ccenaPR=ccenaOST=ccenaST=0;
	Ckodpol *ppol;
    
	y =m_nRowHeight*ycount;
	pDC->TextOut(0,0,"Standatn vkony");
	ycount++;
	for (i=0;i<pDoc->m_zarazkaST;i++){
		ppol=pDoc->poleST[i];
		// if number of current item is null, skip this 
		if (ppol->pocetInt==0) continue;
		y =m_nRowHeight*ycount++;
		ccenaST+=ppol->cena*ppol->pocetInt;
		cntST++;
		OnDrawRow(pDC,y,ppol,"ST");
	}
    
	ycount++;
	y =m_nRowHeight*(ycount++);
	pDC->TextOut(0,y,"Protetick vkony");
    
	for (i=0;i<pDoc->m_zarazkaPR;i++){
		ppol=pDoc->polePR[i];
		// if number of current item is null, skip this 
		if (ppol->pocetInt==0) continue;
		y =m_nRowHeight*ycount++;
		ccenaPR+=ppol->cena*ppol->pocetInt;
		cntPR++;
		OnDrawRow(pDC,y,ppol,"PR");
	}

	ycount++;
	y =m_nRowHeight*(ycount++);
	pDC->TextOut(0,y,"Ostatn vkony");

	for (i=0;i<pDoc->m_zarazkaOST;i++){
		ppol=pDoc->poleOST[i];
		// if number of current item is null, skip this 
		if (ppol->pocetFloat==0) continue;
        y =m_nRowHeight*ycount++;
		ccenaOST+=ppol->cena*ppol->pocetFloat;
		cntOST++;
		OnDrawRow(pDC,y,ppol,"OST");
	}

    TEXTMETRIC tm;
    pDC->GetTextMetrics(&tm);

	ycount++;
	y =m_nRowHeight*(ycount++);
	CString str="Standartnch vkon:";
	int charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%d",cntST);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

	y =m_nRowHeight*(ycount++);
	str="Protetickch vkon:";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
   	str.Format("%d",cntPR);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

	y =m_nRowHeight*(ycount++);
	str="Ostatnch vkon:";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%d",cntOST);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

	ycount++;
	y =m_nRowHeight*(ycount++);
	str="Cena standartnch vkon:";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%.2f",ccenaST);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

	y =m_nRowHeight*(ycount++);
	str="Cena protetickch vkon:";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%.2f",ccenaPR);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

	y =m_nRowHeight*(ycount++);
	str="Cena ostatnch vkon:";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%.2f",ccenaOST);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);
    
	y =m_nRowHeight*(ycount++);
	str="Cena vech vkon celkem: ";
	charcnt=str.GetLength()+1;
	pDC->TextOut(0,y,str);
	str.Format("%.2f",ccenaST+ccenaPR+ccenaOST);
	pDC->TextOut(charcnt*tm.tmAveCharWidth,y,str);

}

/////////////////////////////////////////////////////////////////////////////
// CVyp4View diagnostics

#ifdef _DEBUG
void CVyp4View::AssertValid() const
{
	CScrollView::AssertValid();
}

void CVyp4View::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVyp4View message handlers

void CVyp4View::GetRowWidthHeight(CDC * pDC, int & nRowWidth, int & nRowHeight)
{
	TEXTMETRIC tm;
	pDC->GetTextMetrics(&tm);
	nRowWidth = tm.tmAveCharWidth * (20);
	nRowHeight = tm.tmHeight * 1; // 2 lines of text
}

void CVyp4View::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	// The size of text that is displayed, printed or previewed changes
	// depending on the DC.  We explicitly call OnPrepareDC() to prepare
	// CClientDC objects used for calculating text positions and to
	// prepare the text metric member variables of this object.
	// The framework also calls OnPrepareDC() before passing the DC to
	// OnDraw().

	CScrollView::OnPrepareDC(pDC, pInfo);
    GetRowWidthHeight(pDC,m_nRowWidth,m_nRowHeight);
}

void CVyp4View::OnDrawRow(CDC * pDC, int y, Ckodpol* ppol,CString kod)
{
   TEXTMETRIC tm;
   pDC->GetTextMetrics(&tm);

   char textrow[256]; 
   sprintf(textrow,"%d",ppol->dejkod());
   pDC->TextOut(0,y,textrow);
   if (kod!="OST"){
	   sprintf(textrow,"%d",ppol->pocetInt);
       pDC->TextOut(15*tm.tmAveCharWidth,y,textrow);
       sprintf(textrow,"%.2f",ppol->cena*ppol->pocetInt);
       pDC->TextOut(25*tm.tmAveCharWidth,y,textrow);
   }
   else{
	   sprintf(textrow,"%.2f",ppol->pocetFloat);
       pDC->TextOut(15*tm.tmAveCharWidth,y,textrow);
       sprintf(textrow,"%.2f",ppol->cena*ppol->pocetFloat);
       pDC->TextOut(25*tm.tmAveCharWidth,y,textrow);
   }
}

CVykazy1Doc* CVyp4View::GetDocument()
{
 return (CVykazy1Doc*)m_pDocument;
}

void CVyp4View::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    CVykazy1Doc *pDoc=GetDocument(); 
	CSize sizeTotal;

	// TODO: Add your specialized code here and/or call the base class
	CClientDC dc(this);
	TEXTMETRIC tm;
    dc.GetTextMetrics(&tm);
	int rows=(pDoc->m_zarazkaST+pDoc->m_zarazkaPR+pDoc->m_zarazkaOST+14);
    sizeTotal.cy=rows*tm.tmHeight;
	sizeTotal.cx=45*tm.tmAveCharWidth;
	
	SetScrollSizes(MM_TEXT,sizeTotal);
}

void CVyp4View::OnFilePrintPreview() 
{
 	//TODO: Add your command handler code here
	CView::OnFilePrintPreview();
}

BOOL CVyp4View::OnPreparePrinting(CPrintInfo* pInfo) 
{
	//TODO: call DoPreparePrinting to invoke the Print dialog box
	return DoPreparePrinting(pInfo);
}

void CVyp4View::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	CScrollView::OnPrint(pDC, pInfo);
}

void CVyp4View::OnFilePrint() 
{
	// TODO: Add your command handler code here
	CView::OnFilePrint();
}
