// vykazy1.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MainFrm.h"
#include "kodpol.h"  ////nutne pro Cvykazy1Doc
#include "vykazy1Doc.h"
#include "Vyp4View.h"
#include "vykazy1.h"
#include "Vyp1View.h"
#include "Vyp2View.h"
#include "Vyp3View.h"
#include "VykChldFrame.h"
#include "hyperlink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVykazy1App

BEGIN_MESSAGE_MAP(CVykazy1App, CWinApp)
	//{{AFX_MSG_MAP(CVykazy1App)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVykazy1App construction

CVykazy1App::CVykazy1App()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVykazy1App object

CVykazy1App theApp;

/////////////////////////////////////////////////////////////////////////////
// CVykazy1App initialization

BOOL CVykazy1App::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings(3);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.
 
	//vytvorime 2x doctemplate kvuli praci se dvema MDICHILD okny
	//check view a bookview a registrujeme je s CWinApp pomoci volani
	// AddDocTemplate. Kdybychom udelali jen tohle, framework si bude 
	// myslet, ze aplikace ma dva typy dokumentu a pro volbe FILE/NEW
	// by nam dal dialogem vyber ze dvou dokumentu (check book)
	
	
	// We create two doc template objects to orchestrate the creation of two
	// distinct MDI children-hosted views of the document: (1) the check
	// check view and (2) the book view. To vyresime tim ,ze vymazeme treti
	// string z dokumenttemplate pro check/frame view, vyslovne stringy
	// pro domunety IDR_BOOKFRAME a IDR_CHECKFRAME prisluseji 
	//
	//       "Book\nchecks\nCheck Book\n
	//        Check Book File (*.chb)\n.chb\n
	//        ChkBookFileType\nCheck Book File Type"
	// a
	//       "Check\nchecks\n\n
	//        Check Book File (*.chb)\n.chb\n
	//        ChkBookFileType\nCheck Book File Type"
	//
	// nejni zadny GetDocString(CDocTemplate::fileNewName) pro
	// druhy dokument template a proto si CWinApp mysli, ze aplikace ma jen
	// jeden dokument ("Check Book") specifikovany jako prvni doctemplate 
	// proto se nebude vytvaret zadny dialog po volbe file/new 
	
	m_pVyk1ViewTemplate = new CMultiDocTemplate(IDR_VYK1FRAME,
			RUNTIME_CLASS(CVykazy1Doc),
			RUNTIME_CLASS(CVykChldFrame),
			RUNTIME_CLASS(CVyp1View));
	AddDocTemplate(m_pVyk1ViewTemplate);

	m_pVyk2ViewTemplate = new CMultiDocTemplate(IDR_VYK2FRAME,
			RUNTIME_CLASS(CVykazy1Doc),
			RUNTIME_CLASS(CVykChldFrame),
			RUNTIME_CLASS(CVyp2View));
	AddDocTemplate(m_pVyk2ViewTemplate);
    
	m_pVyk3ViewTemplate = new CMultiDocTemplate(IDR_VYK3FRAME,
			RUNTIME_CLASS(CVykazy1Doc),
			RUNTIME_CLASS(CVykChldFrame),
			RUNTIME_CLASS(CVyp3View));
	AddDocTemplate(m_pVyk3ViewTemplate);

	m_pVyk4ViewTemplate = new CMultiDocTemplate(IDR_VYK4FRAME,
			RUNTIME_CLASS(CVykazy1Doc),
			RUNTIME_CLASS(CVykChldFrame),
			RUNTIME_CLASS(CVyp4View));
	AddDocTemplate(m_pVyk4ViewTemplate);

	//vytvorime hlavni MDI frame window.

	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	
	m_pMainWnd = pMainFrame;
	int nCmdShow = m_nCmdShow;
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

     // setup main window
	nCmdShow = !cmdInfo.m_bRunEmbedded ? m_nCmdShow : SW_HIDE;
	m_nCmdShow = SW_HIDE;
	//((CMainFrame*)m_pMainWnd)->InitialShowWindow(nCmdShow);

	if (!cmdInfo.m_bRunEmbedded)
	{
		m_pMainWnd->UpdateWindow();

		if (!m_pMainWnd->IsIconic() && cmdInfo.m_bShowSplash &&
			m_splash.Create(m_pMainWnd))
		{
			m_splash.ShowWindow(SW_SHOW);
			m_splash.UpdateWindow();
			m_splash.SetTimer(1, 500, NULL);
		}
		m_dwSplashTime = ::GetCurrentTime();
			if (m_splash.m_hWnd != NULL)

		do{	}
	    while (::GetCurrentTime() - m_dwSplashTime < 2000);
		// timeout expired
		m_pMainWnd->UpdateWindow();
	}

	// open default file if command line doesn't have /Embedding
	if (!cmdInfo.m_bRunEmbedded)
	{
		// Dispatch commands specified on the command line
		if (!ProcessShellCommand(cmdInfo))
			return FALSE;
	
		m_nCmdShow = nCmdShow;
		m_pMainWnd->UpdateWindow();
	}

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
    //destroy the splash window
	m_splash.DestroyWindow();
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CHyperLink m_hyperLink1;
	CHyperLink m_hyperLink2;
    CHyperLink m_hyperLink3;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_URL1, m_hyperLink1);
    DDX_Control(pDX, IDC_URL2, m_hyperLink2);
    DDX_Control(pDX, IDC_URL3, m_hyperLink3);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CVykazy1App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CVykazy1App commands

//pretizena metoda tridy CWinApp, ktera se vola, po provedeni opendialogu
//a pred otevrenim dokumentu, po jejim skonceni je otevteno view podle
// doctemplate, 
//!!!!!mus bt deklarovna jako VIRTUAL!!!!!!
CDocument* CVykazy1App::OpenDocumentFile(LPCTSTR lpszFileName) 
{
	// TODO: Add your specialized code here and/or call the base class
	// CWinApp::OpenDocmentFile vytvori prvni MDI okno pro prvni 
	// dokument podle prvni doctemplate

	CVykazy1Doc* pDoc = (CVykazy1Doc*)CWinApp::OpenDocumentFile(lpszFileName);
	if (pDoc == NULL)
		return NULL;
    
	//odkomentovanim se povolbe OPEN otevrou vsechna 4 view  
	//tak se vytvori druhe view (druhe MDI Okno)
/*	CFrameWnd* pNewFrame = m_pVyk2ViewTemplate->CreateNewFrame(pDoc, NULL);
	if (pNewFrame == NULL)
		return pDoc;
	m_pVyk2ViewTemplate->InitialUpdateFrame(pNewFrame, pDoc);
	
	CMDIChildWnd* pNewFrame2 =(CMDIChildWnd*)m_pVyk3ViewTemplate->CreateNewFrame(pDoc,NULL);
    if (pNewFrame2 == NULL)
		return pDoc;
    m_pVyk3ViewTemplate->InitialUpdateFrame(pNewFrame2, pDoc);
*/ 
	return pDoc;

}

void CVykazy1App::OnFileNew() {
 
 CMDIFrameWnd *pFrame =(CMDIFrameWnd*)m_pMainWnd;
 CMDIChildWnd *pChild = 
             (CMDIChildWnd *) pFrame->GetActiveFrame();
 CVykazy1Doc* pDoc2 = (CVykazy1Doc*)pChild->GetActiveDocument();
 
 //MFC CDocument::OnfileClose hack
 if (pDoc2!=NULL) {
	 if (!pDoc2->SaveModified())
		return;
	 // shut it down
	  pDoc2->OnCloseDocument();
	// this should destroy the document
 }

 CVykazy1Doc* pDoc = (CVykazy1Doc*)m_pVyk1ViewTemplate->OpenDocumentFile(NULL,TRUE);

//odkomentovanim se zobrazi vsechna 4 view po volbe NEW 
/* CMDIChildWnd* pNewFrame =(CMDIChildWnd*)m_pVyk2ViewTemplate->CreateNewFrame(pDoc,NULL);
 if (pNewFrame == NULL)
		return;
 m_pVyk2ViewTemplate->InitialUpdateFrame(pNewFrame, pDoc);

 CMDIChildWnd* pNewFrame2 =(CMDIChildWnd*)m_pVyk3ViewTemplate->CreateNewFrame(pDoc,NULL);
 if (pNewFrame2 == NULL)
		return;
 m_pVyk3ViewTemplate->InitialUpdateFrame(pNewFrame2, pDoc);
 CMDIChildWnd* pNewFrame3 =(CMDIChildWnd*)m_pVyk4ViewTemplate->CreateNewFrame(pDoc,NULL);
 if (pNewFrame3 == NULL)
		return;
 m_pVyk4ViewTemplate->InitialUpdateFrame(pNewFrame3, pDoc);

 // Tile the two MDI children windows within the MDI frame window.
/*
 ASSERT_KINDOF(CMDIChildWnd, pNewFrame);
 CMDIFrameWnd* pMDIFrameWnd = ((CMDIChildWnd*)pNewFrame)->GetMDIFrame();
 ASSERT(pMDIFrameWnd != NULL);
 pMDIFrameWnd->MDITile(MDITILE_HORIZONTAL);
*/
} 


void CVykazy1App::OnFileOpen() 
{
	// TODO: Add your command handler code here
	//naleznu stary dokument a znicim ho
	CMDIFrameWnd *pFrame = (CMDIFrameWnd*)m_pMainWnd;
    CMDIChildWnd *pChild = 
             (CMDIChildWnd *) pFrame->GetActiveFrame();
    CVykazy1Doc* pDoc2 = (CVykazy1Doc*)pChild->GetActiveDocument();
 
    //MFC CDocument::OnfileClose hack
    if (pDoc2!=NULL) {
	 if (!pDoc2->SaveModified())
		return;
	 // shut it down
	  pDoc2->OnCloseDocument();
	// this should destroy the document
	}
    CWinApp::OnFileOpen();
}



BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	m_hyperLink1.SetURL(_T("http://www.mujweb.cz/www/optik"));
	m_hyperLink2.SetURL(_T("mailto:koubel@volny.cz"));
	m_hyperLink3.SetURL(_T("http://expat.sourceforge.net"));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	               // EXCEPTION: OCX Property Pages should return FALSE
}
