// vykazy1Doc.h : interface of the CVykazy1Doc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_VYKAZY1DOC_H__27CAFA8B_8A69_11D4_B55E_9482406F8078__INCLUDED_)
#define AFX_VYKAZY1DOC_H__27CAFA8B_8A69_11D4_B55E_9482406F8078__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#define maxST 100
#define maxPR 100
#define maxOST 100


class CVykazy1Doc : public CDocument
{
protected: // create from serialization only
	bool changedef; //if definition of codes are changed
	CVykazy1Doc();
     //three xlm parsing handlers
	static void endXMLelm(void *data, const char *el);
	static void startXMLelm(void *data, const char *el, const char **attr);
    static void texthnd(void *data,const char *text,int len);
	int loadfromXML();
	// static var used in endXMLelm,startXMLelm... 
	static bool XMLerr;
   	DECLARE_DYNCREATE(CVykazy1Doc)
    //for name of section element
	CString section;
    //for name of Item element
	CString sectionItem;
    //definition file need for parsing handler
	FILE* titlefile;
 
// Attributes
public:
Ckodpol* poleST[maxST];
Ckodpol* polePR[maxST];
Ckodpol* poleOST[maxST];
int m_zarazkaST;
int m_zarazkaPR;
int m_zarazkaOST;


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVykazy1Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void defchanged(bool status);
	int pridejOST(Ckodpol *ppol);
	int zmenkod(UINT kodnm);
	int zmenkod(UINT kodm,float pocet);
	int zmenkod(UINT kodnm,UINT hodnota);
	int Uzmenpocet(CString IDchar,int pozice,int pocet);
	int Uzmenpocet(CString IDchar,int pozice,float pocet);
	int pridejST(Ckodpol* ppol);
	int pridejPR(Ckodpol* ppol);
	void setridST(int zac,int kon);
	void setridPR(int zac,int kon);
	void setridOST(int zac,int kon);
	virtual ~CVykazy1Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CVykazy1Doc)
	afx_msg void OnPolAddStn();
	afx_msg void OnPolRemStn();
	afx_msg void OnPolAddPrt();
	afx_msg void OnPolokyVyplnovat();
	afx_msg void OnPolRemPrt();
	afx_msg void OnPolAddOst();
	afx_msg void OnPolRemOst();
	afx_msg void OnPolAktual();
	afx_msg void OnUpdatePolAktual(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VYKAZY1DOC_H__27CAFA8B_8A69_11D4_B55E_9482406F8078__INCLUDED_)
