// PolOSTdlg.cpp : implementation file
//

#include "stdafx.h"
#include "vykazy1.h"
#include "kodpol.h"
#include "PolOSTdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define CTRL2VAR TRUE
#define VAR2CTRL FALSE

/////////////////////////////////////////////////////////////////////////////
// CPolOSTdlg dialog


CPolOSTdlg::CPolOSTdlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPolOSTdlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPolOSTdlg)
	m_kod = 0;
	m_pocetFloat = 0.0f;
	m_nazev = _T("");
	m_cena = 0.0f;
	//}}AFX_DATA_INIT
}


void CPolOSTdlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPolOSTdlg)
	DDX_Text(pDX, IDC_KOD, m_kod);
	DDX_Text(pDX, IDC_MNSTV, m_pocetFloat);
	DDX_Text(pDX, IDC_NAZEV, m_nazev);
	DDX_Text(pDX, IDC_CENA, m_cena);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPolOSTdlg, CDialog)
	//{{AFX_MSG_MAP(CPolOSTdlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPolOSTdlg message handlers

void CPolOSTdlg::OnOK() 
{
	// TODO: Add extra validation here
    UpdateData(CTRL2VAR);
	if (m_cena<0) {
	    AfxMessageBox( "Cena mus bt vt ne 0!",
  		            MB_OK|MB_ICONSTOP,0 );
	    ((CEdit*)GetDlgItem(IDC_CENA))->SetFocus();
		return;
	}
    if (m_pocetFloat<0) {
	    AfxMessageBox("Mnostv mus bt vt ne 0!",
  		            MB_OK|MB_ICONSTOP,0 );
	    ((CEdit*)GetDlgItem(IDC_PVYK))->SetFocus();
		return;
	}
	CDialog::OnOK();
}

void CPolOSTdlg::LoaddatOSTkode(Ckodpol * ppol)
{
 m_cena=ppol->cena;
 m_kod=ppol->dejkod();
 m_nazev=ppol->nazev;
 m_pocetFloat=ppol->dejpocetFloat();
}

void CPolOSTdlg::SavedatOSTkode(Ckodpol * ppol)
{
 ppol->cena=m_cena;
 ppol->nazev=m_nazev;
 ppol->pocetFloat=m_pocetFloat;
}
