// Poldialog.cpp : implementation file
//

#include "stdafx.h"
#include "kodpol.h"
#include "vykazy1Doc.h"
#include "vykazy1.h"
#include "Poldialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#define CTRL2VAR TRUE
#define VAR2CTRL FALSE

/////////////////////////////////////////////////////////////////////////////
// CPoldialog dialog


CPoldialog::CPoldialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPoldialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPoldialog)
	m_nazev = _T("");
	m_cena = 0.0f;
	m_pvyk = 0;
	m_kod = 0;
	//}}AFX_DATA_INIT
}


void CPoldialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPoldialog)
	DDX_Text(pDX, IDC_NAZEV, m_nazev);
	DDX_Text(pDX, IDC_CENA, m_cena);
	DDX_Text(pDX, IDC_PVYK, m_pvyk);
	DDX_Text(pDX, IDC_KOD, m_kod);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPoldialog, CDialog)
	//{{AFX_MSG_MAP(CPoldialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPoldialog message handlers

void CPoldialog::OnOK() 
{
	// TODO: Add extra validation here
    UpdateData(CTRL2VAR);
	if (m_cena<0) {
	    AfxMessageBox( "Cena mus bt vt ne 0!",
  		            MB_OK|MB_ICONSTOP,0 );
	    ((CEdit*)GetDlgItem(IDC_CENA))->SetFocus();
		return;
	}
    if (m_pvyk<0) {
	    AfxMessageBox("poet vkon mus bt vt ne 0!",
  		            MB_OK|MB_ICONSTOP,0 );
	    ((CEdit*)GetDlgItem(IDC_PVYK))->SetFocus();
		return;
	}
	CDialog::OnOK();
}

void CPoldialog::LoaddatSTPRkode(Ckodpol * ppol)
{
 m_cena=ppol->cena;
 m_kod=ppol->dejkod();
 m_nazev=ppol->nazev;
 m_pvyk=ppol->pocetInt;
}

void CPoldialog::SavedatSTPRkode(Ckodpol * ppol)
{
 ppol->cena=m_cena;
 ppol->nazev=m_nazev;
 ppol->pocetInt=m_pvyk;
}

