// vykazy1Doc.cpp : implementation of the CVykazy1Doc class
//

#include <stdio.h>
#include "stdafx.h"
#include "kodpol.h"    //musi byt pred includem Documentu
#include "vykazy1Doc.h"
#include "vykazy1.h"
#include "Poldialog.h"
#include "Adddialog.h"
#include "Delpoldialog.h"
#include "Vypldialog.h"
#include "MainFrm.h"
#include "Vyp3View.h"
#include "expat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define XML_out
#define XML_in

//for XML parser
#define BUFFSIZE	8192

//document pointer for static parsing handlers
CVykazy1Doc* aktdoc;
//declaration static variable
bool CVykazy1Doc::XMLerr;

/////////////////////////////////////////////////////////////////////////////
// CVykazy1Doc

IMPLEMENT_DYNCREATE(CVykazy1Doc, CDocument)

BEGIN_MESSAGE_MAP(CVykazy1Doc, CDocument)
	//{{AFX_MSG_MAP(CVykazy1Doc)
	ON_COMMAND(ID_POL_ADD_STN, OnPolAddStn)
	ON_COMMAND(ID_POL_REM_STN, OnPolRemStn)
	ON_COMMAND(ID_POL_ADD_PRT, OnPolAddPrt)
	ON_COMMAND(ID_POLOKY_VYPLNOVAT, OnPolokyVyplnovat)
	ON_COMMAND(ID_POL_REM_PRT, OnPolRemPrt)
	ON_COMMAND(ID_POL_ADD_OST, OnPolAddOst)
	ON_COMMAND(ID_POL_REM_OST, OnPolRemOst)
	ON_COMMAND(ID_POL_AKTUAL, OnPolAktual)
	ON_UPDATE_COMMAND_UI(ID_POL_AKTUAL, OnUpdatePolAktual)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVykazy1Doc construction/destruction

CVykazy1Doc::CVykazy1Doc()
{
  // TODO: add one-time construction code here
  // when user selecet file open , opened document can
  // contains some codes, which arent in definotion file
  // hence changedef is true
	changedef=true;
	XMLerr=false;
}

CVykazy1Doc::~CVykazy1Doc()
{
}

BOOL CVykazy1Doc::OnNewDocument()
{
 if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
    //nacteni definic a inicializace dat
#ifndef XML_in 
 char* pszFileName = "definice2.txt";
 FILE* myfile;
 char retez[256];
 char *retez2;
 int poc=0;
#endif 

 m_zarazkaST=0;
 m_zarazkaPR=0;
 m_zarazkaOST=0;
 
#ifdef XML_in
 int var=loadfromXML();
 if (!var) return FALSE; 

#else
 if((myfile=fopen(pszFileName,"rt"))==NULL)
 {
  //    AfxMessageBox( "Nemohu otevt soubor definice2.txt",
  //		            MB_OK|MB_ICONSTOP,0 );
	return FALSE;
 }

 while (fgets(retez,256,myfile)!=NULL){
  if (strcmp("STANDART\n",retez)==0)
	while (strcmp(fgets(retez,256,myfile),"KONECST\n")!=0)
	{
     poleST[m_zarazkaST]= new Ckodpol();
	 poleST[m_zarazkaST]->nastavkod(atoi(retez));
     fgets(retez,256,myfile);	 
     poc=strlen(retez);
	 retez2=(char*)malloc(poc);
	 memset(retez2,0,poc);
	 strncpy(retez2,retez,poc-1);
	 poleST[m_zarazkaST]->nazev=retez2;
	 free(retez2);
	 fgets(retez,256,myfile);
     poleST[m_zarazkaST]->cena=(float)atof(retez);
	 poleST[m_zarazkaST]->pocetInt=0;
	 m_zarazkaST++;
    }
  if (strcmp("PROTETIKA\n",retez)==0)
	while (strcmp(fgets(retez,256,myfile),"KONECPR\n")!=0)
	{
     polePR[m_zarazkaPR]= new Ckodpol();
	 polePR[m_zarazkaPR]->nastavkod(atoi(retez));
     fgets(retez,256,myfile);	 
     poc=strlen(retez);
	 retez2=(char*)malloc(poc);
	 memset(retez2,0,poc);
	 strncpy(retez2,retez,poc-1);
	 polePR[m_zarazkaPR]->nazev=retez2;
	 free(retez2);
	 fgets(retez,256,myfile);
     polePR[m_zarazkaPR]->cena=(float)atof(retez);
	 polePR[m_zarazkaPR]->pocetInt=0;
	 m_zarazkaPR++;
    }
  if (strcmp("OSTATNI\n",retez)==0)
	while (strcmp(fgets(retez,256,myfile),"KONECKV\n")!=0)
	{
     poleOST[m_zarazkaOST]= new Ckodpol();
	 poleOST[m_zarazkaOST]->nastavkod(atoi(retez));
     fgets(retez,256,myfile);	 
     poc=strlen(retez);
	 retez2=(char*)malloc(poc);
	 memset(retez2,0,poc);
	 strncpy(retez2,retez,poc-1);
	 poleOST[m_zarazkaOST]->nazev=retez2;
	 free(retez2);
	 fgets(retez,256,myfile);
     poleOST[m_zarazkaOST]->cena=(float)atof(retez);
	 poleOST[m_zarazkaOST]->pocetFloat=0;
	 m_zarazkaOST++;
    }
  if (strcmp(retez,"END DEFFILE\n")==0) break;
 }
 fclose(myfile);
#endif
 if (m_zarazkaST>1) setridST(0,m_zarazkaST-1);
 if (m_zarazkaPR>1) setridPR(0,m_zarazkaPR-1);
 if (m_zarazkaOST>1) setridOST(0,m_zarazkaOST-1);
 return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CVykazy1Doc serialization

void CVykazy1Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
     // TODO: add storing code here
		ar<<m_zarazkaST;
        ar<<m_zarazkaPR;
        ar<<m_zarazkaOST;
 		for (int i=0;i<m_zarazkaST;i++){
         ar<<(double)poleST[i]->cena;
         ar<<(int)poleST[i]->dejkod();
         ar<<poleST[i]->nazev;
         ar<<(int)poleST[i]->dejpocetInt();
         ar<<(double)poleST[i]->dejpocetFloat();
		}
        for (i=0;i<m_zarazkaPR;i++){
         ar<<(double)polePR[i]->cena;
         ar<<(int)polePR[i]->dejkod();
         ar<<polePR[i]->nazev;
         ar<<(int)polePR[i]->dejpocetInt();
         ar<<(double)polePR[i]->dejpocetFloat();
		}
        for (i=0;i<m_zarazkaOST;i++){
         ar<<(double)poleOST[i]->cena;
         ar<<(int)poleOST[i]->dejkod();
         ar<<poleOST[i]->nazev;
         ar<<(int)poleOST[i]->dejpocetInt();
         ar<<(double)poleOST[i]->dejpocetFloat();
		}
	}
	else
	{
		// TODO: add loading code here
		double pk;
		int pk2;

		ar>>m_zarazkaST;
        ar>>m_zarazkaPR;
        ar>>m_zarazkaOST;
 		for (int i=0;i<m_zarazkaST;i++){
  		 Ckodpol* ppol=new Ckodpol;
		 poleST[i]=ppol;
		 ar>>pk; 
		 poleST[i]->cena=(float)pk;
         ar>>pk2; 
		 poleST[i]->nastavkod(pk2);
		 ar>>poleST[i]->nazev;
         ar>>pk2;
		 poleST[i]->pocetInt=(UINT)pk2;
         ar>>pk;
		 poleST[i]->pocetFloat=(float)pk;
		}
 		for (i=0;i<m_zarazkaPR;i++){
  		 Ckodpol* ppol=new Ckodpol;
		 polePR[i]=ppol;
		 ar>>pk; 
		 polePR[i]->cena=(float)pk;
         ar>>pk2; 
		 polePR[i]->nastavkod(pk2);
		 ar>>polePR[i]->nazev;
         ar>>pk2;
		 polePR[i]->pocetInt=(UINT)pk2;
         ar>>pk;
		 polePR[i]->pocetFloat=(float)pk;
		}
        for (i=0;i<m_zarazkaOST;i++){
  		 Ckodpol* ppol=new Ckodpol;
		 poleOST[i]=ppol;
		 ar>>pk; 
		 poleOST[i]->cena=(float)pk;
         ar>>pk2; 
		 poleOST[i]->nastavkod(pk2);
		 ar>>poleOST[i]->nazev;
         ar>>pk2;
		 poleOST[i]->pocetInt=(UINT)pk2;
         ar>>pk;
		 poleOST[i]->pocetFloat=(float)pk;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CVykazy1Doc diagnostics

#ifdef _DEBUG
void CVykazy1Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVykazy1Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVykazy1Doc commands

//trideni quicksort=rozdel a panuj,
// rozdelit na pulku, a v pravo mensi a v levo vetsi prvky nez ten prostredni,
// pak to same aplikovat na oba useky}


void CVykazy1Doc::setridST(int zac,int kon)
{
int x; //delici hodnota, index
int i,j; //posuvne indexi v poli
Ckodpol* q;
int p1,p2,p3;

x=(zac+kon)/2; //stred trideneho useku
i=zac;
j=kon;
p1=poleST[i]->dejkod();
p2=poleST[j]->dejkod();
p2=poleST[j]->dejkod();
p3=poleST[x]->dejkod();
do {
 while (p1<p3){
  i++;
  p1=poleST[i]->dejkod();
 }
 while (p2>p3) {
  j--;
  p2=poleST[j]->dejkod();
 }  
 if (i<=j){  //prehodi prvky s indexi i,j
  q=poleST[i];
  poleST[i]=poleST[j];
  poleST[j]=q;
  if (i!=m_zarazkaST) i++;
  if (j!=0) j--;
  p1=poleST[i]->dejkod();
  p2=poleST[j]->dejkod();
 }
} while (i<j);
//usek je rozdelen na dva
//zac-j i-kon, ktere setridime rekurzi
if (zac<j) setridST(zac,j);
if (i<kon) setridST(i,kon);
}

void CVykazy1Doc::setridPR(int zac,int kon)
{
int x; //delici hodnota, index
int i,j; //posuvne indexi v poli
Ckodpol* q;
int p1,p2,p3;

x=(zac+kon)/2; //stred trideneho useku
i=zac;
j=kon;
p1=polePR[i]->dejkod();
p2=polePR[j]->dejkod();
p2=polePR[j]->dejkod();
p3=polePR[x]->dejkod();
do {
 while (p1<p3){
  i++;
  p1=polePR[i]->dejkod();
 }
 while (p2>p3) {
  j--;
  p2=polePR[j]->dejkod();
 }  
 if (i<=j){  //prehodi prvky s indexi i,j
  q=polePR[i];
  polePR[i]=polePR[j];
  polePR[j]=q;
  if (i!=m_zarazkaPR) i++;
  if (j!=0) j--;
  p1=polePR[i]->dejkod();
  p2=polePR[j]->dejkod();
 }
} while (i<j);
//usek je rozdelen na dva
//zac-j i-kon, ktere setridime rekurzi
if (zac<j) setridPR(zac,j);
if (i<kon) setridPR(i,kon);
}


void CVykazy1Doc::setridOST(int zac, int kon)
{
int x; //delici hodnota, index
int i,j; //posuvne indexi v poli
Ckodpol* q;
int p1,p2,p3;

x=(zac+kon)/2; //stred trideneho useku
i=zac;
j=kon;
p1=poleOST[i]->dejkod();
p2=poleOST[j]->dejkod();
p2=poleOST[j]->dejkod();
p3=poleOST[x]->dejkod();
do {
 while (p1<p3){
  i++;
  p1=poleOST[i]->dejkod();
 }
 while (p2>p3) {
  j--;
  p2=poleOST[j]->dejkod();
 }  
 if (i<=j){  //prehodi prvky s indexi i,j
  q=poleOST[i];
  poleOST[i]=poleOST[j];
  poleOST[j]=q;
  if (i!=m_zarazkaOST) i++;
  if (j!=0) j--;
  p1=poleOST[i]->dejkod();
  p2=poleOST[j]->dejkod();
 }
} while (i<j);
//usek je rozdelen na dva
//zac-j i-kon, ktere setridime rekurzi
if (zac<j) setridOST(zac,j);
if (i<kon) setridOST(i,kon);
}

int CVykazy1Doc::pridejST(Ckodpol * ppol)
{
 //kontrolaST
 int kod1,kod2; 
 int i;
 for(i=0;i<m_zarazkaST;i++){
  kod1=poleST[i]->dejkod();
  kod2=ppol->dejkod();
  if (kod1==kod2){
   AfxMessageBox( "kd ji existuje!",
  	            MB_OK|MB_ICONSTOP,0 );
   return -1; 
  }
 }
 if (++m_zarazkaST>maxST-1){
  AfxMessageBox("ji nelze pidat dal kd!!",
  	            MB_OK|MB_ICONSTOP,0 );
  m_zarazkaST--;
  return -1; 
 }
 poleST[m_zarazkaST-1]=ppol;
 
 this->defchanged(true); //change in definition new code is added
 return 1;
}

int CVykazy1Doc::pridejPR(Ckodpol * ppol)
{
 //kontrolaPR
 int kod1,kod2; 
 int i;
 for(i=0;i<m_zarazkaPR;i++){
  kod1=polePR[i]->dejkod();
  kod2=ppol->dejkod();
  if (kod1==kod2){
   AfxMessageBox( "kd ji existuje!",
  	            MB_OK|MB_ICONSTOP,0 );
   return -1; 
  }
 }
 if (++m_zarazkaPR>maxPR-1){
  AfxMessageBox("ji nelze pidat dal kd!!",
  	            MB_OK|MB_ICONSTOP,0 );
  m_zarazkaPR--;
  return -1; 
 }
 polePR[m_zarazkaPR-1]=ppol;
 
 this->defchanged(true); //change in definition new code is added
 return 1;
}



void CVykazy1Doc::OnPolAddStn() 
{
	// TODO: Add your command handler code here
	CAdddialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
    Ckodpol* ppol=new Ckodpol();
	dlg.Savedatkode(ppol);
	if (!pridejST(ppol)) return;
	SetModifiedFlag();
 	if (m_zarazkaST>1) setridST(0,m_zarazkaST-1);
	/*
	//find view, that has to be updated
	CView* pView;
	POSITION pos = this->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = this->GetNextView(pos);
		if (pView->IsKindOf(RUNTIME_CLASS(CVyp3View)))
		{          
			pView->OnUpdate();
			break;
		}
		pView = this->GetNextView(pos);
	}
	*/
	UpdateAllViews(NULL);
}

void CVykazy1Doc::OnPolRemStn() 
{
	UINT delkod,i;
	UINT pozice=0;
    BOOL nalez=false;
    
	// TODO: Add your command handler code here
    CDelpoldialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
   	dlg.Savedatkode(&delkod);

	//hledani kodu
	for (i=0;i<(UINT)m_zarazkaST;i++){
		if (poleST[i]->dejkod()==delkod) {
			nalez=true;
			pozice=i;
		}
	}
	if (nalez) {
		if (pozice==(UINT)m_zarazkaST){
			delete poleST[m_zarazkaST--];
            AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
            UpdateAllViews(NULL);
			setridST(0,m_zarazkaST-1);
			SetModifiedFlag();
			this->defchanged(true); //change in definition code removed
			return;
		}
        delete poleST[pozice]; //pokud neni na konci
		for (i=pozice;i<(UINT)(m_zarazkaST-1);i++){
			poleST[i]=poleST[i+1];
		}
		m_zarazkaST--;
		AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
        UpdateAllViews(NULL);
		if (m_zarazkaST>1) setridST(0,m_zarazkaST-1);
	    SetModifiedFlag();
		this->defchanged(true); //change in definition code removed
		return;
	}
	else 
	 AfxMessageBox("kd nenalezen!",MB_OK|MB_ICONSTOP,0);
}


int CVykazy1Doc::zmenkod(UINT kodnm,UINT hodnota){
BOOL nalez;
UINT pozice,i;

//hledani v poli ST
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaST;i++){
	if (poleST[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
	Uzmenpocet("S",pozice,(int)hodnota);
    return 1;
 }

 //hledani v poli PR
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaPR;i++){
	if (polePR[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
  Uzmenpocet("PR",pozice,(int)hodnota);
  return 1;
 }
 AfxMessageBox("Kd nepat do standartnich ani protetickch kd!",
		       MB_OK|MB_ICONSTOP,0 );
 return 0;
}



int CVykazy1Doc::Uzmenpocet(CString IDchar, int pozice, int pocet)
{
	if (IDchar=="S"){
		poleST[pozice]->ZmenpocetInt(pocet);
		return 1;
	}
	if (IDchar=="PR"){
		polePR[pozice]->ZmenpocetInt(pocet);
		return 1;
	}
    return 0;
}


int CVykazy1Doc::Uzmenpocet(CString IDchar, int pozice, float pocet)
{
	if (IDchar=="OST"){
		poleOST[pozice]->ZmenpocetFloat(pocet);
		return 1;
	}
    return 0;
}



//pouze pro OST kody
int CVykazy1Doc::zmenkod(UINT kodnm,float pocet){
BOOL nalez;
UINT pozice,i;

 //hledani v poli OST
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaOST;i++){
	if (poleOST[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
	Uzmenpocet("OST",pozice,(float)pocet);
    return 1;
 }
 AfxMessageBox("Kd nepat do ostatnch kd!",
		       MB_OK|MB_ICONSTOP,0 );
 return 0;
}

int CVykazy1Doc::zmenkod(UINT kodnm)
{
BOOL nalez;
UINT pozice,i;

//hledani v poli ST
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaST;i++){
	if (poleST[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
	Uzmenpocet("S",pozice,(int)1);
    return 1;
 }

//hledani v poli PR
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaPR;i++){
	if (polePR[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
	Uzmenpocet("PR",pozice,(int)1);
    return 1;
 }

//hledani v poli OST
 nalez=false;
 for (i=0;i<(UINT)m_zarazkaOST;i++){
	if (poleOST[i]->dejkod()==kodnm){
		nalez=true;
		pozice=i;
	}
 }
 if (nalez){
	Uzmenpocet("OST",pozice,(float)1);
    return 1;
 }
 AfxMessageBox("Kd neexistuje!",
		       MB_OK|MB_ICONSTOP,0 );
 return 0; 
}

void CVykazy1Doc::OnPolAddPrt() 
{
	// TODO: Add your command handler code here
	CAdddialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
    Ckodpol* ppol=new Ckodpol();
	dlg.Savedatkode(ppol);
	if (!pridejPR(ppol)) return;
	SetModifiedFlag();
	if (m_zarazkaPR>1) setridPR(0,m_zarazkaPR-1);
	UpdateAllViews(NULL);
}



void CVykazy1Doc::OnPolokyVyplnovat() 
{
	// TODO: Add your command handler code here
	CVypldialog dlg;
	dlg.m_pDoc=this;
	if (dlg.DoModal()==IDCANCEL) return;
	UpdateAllViews(NULL);
}

void CVykazy1Doc::OnPolRemPrt() 
{
	UINT delkod,i;
	UINT pozice=0;
    BOOL nalez=false;
    
	// TODO: Add your command handler code here
    CDelpoldialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
   	dlg.Savedatkode(&delkod);

	//hledani kodu
	for (i=0;i<(UINT)m_zarazkaPR;i++){
		if (polePR[i]->dejkod()==delkod) {
			nalez=true;
			pozice=i;
		}
	}
	if (nalez) {
		if (pozice==(UINT)m_zarazkaPR){
			delete poleST[m_zarazkaPR--];
            AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
            UpdateAllViews(NULL);
			setridPR(0,m_zarazkaPR-1);
			SetModifiedFlag();
			this->defchanged(true); //change in definition code removed
			return;
		}
        delete polePR[pozice]; //pokud neni na konci
		for (i=pozice;i<(UINT)(m_zarazkaPR-1);i++){
			polePR[i]=polePR[i+1];
		}
		m_zarazkaPR--;
		AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
        UpdateAllViews(NULL);
		if (m_zarazkaPR>1) setridPR(0,m_zarazkaPR-1);
		SetModifiedFlag();
		this->defchanged(true); //change in definition code removed
		return;
	}
	else 
	 AfxMessageBox("kd nenalezen!",MB_OK|MB_ICONSTOP,0);
}


void CVykazy1Doc::OnPolAddOst() 
{
	// TODO: Add your command handler code here
	CAdddialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
    Ckodpol* ppol=new Ckodpol();
	dlg.Savedatkode(ppol);
	if (!pridejOST(ppol)) return;
	SetModifiedFlag();
 	if (m_zarazkaOST>1) setridOST(0,m_zarazkaOST-1);
	UpdateAllViews(NULL);
}

int CVykazy1Doc::pridejOST(Ckodpol * ppol)
{
//kontrolaOST
 int kod1,kod2; 
 int i;
 for(i=0;i<m_zarazkaOST;i++){
  kod1=poleOST[i]->dejkod();
  kod2=ppol->dejkod();
  if (kod1==kod2){
   AfxMessageBox( "kd ji existuje!",
  	            MB_OK|MB_ICONSTOP,0 );
   return -1; 
  }
 }
 if (++m_zarazkaOST>maxOST-1){
  AfxMessageBox("ji nelze pidat dal kd!!",
  	            MB_OK|MB_ICONSTOP,0 );
  m_zarazkaOST--;
  return -1; 
 }
 poleOST[m_zarazkaOST-1]=ppol;
 this->defchanged(true); //change in definition new code is added
 return 1;
}

void CVykazy1Doc::OnPolRemOst() 
{
	UINT delkod,i;
	UINT pozice=0;
    BOOL nalez=false;
    
	// TODO: Add your command handler code here
    CDelpoldialog dlg;
 	if (dlg.DoModal()==IDCANCEL) return;
   	dlg.Savedatkode(&delkod);

	//hledani kodu
	for (i=0;i<(UINT)m_zarazkaOST;i++){
		if (poleOST[i]->dejkod()==delkod) {
			nalez=true;
			pozice=i;
		}
	}
	if (nalez) {
		if (pozice==(UINT)m_zarazkaOST){
			delete poleOST[m_zarazkaOST--];
            AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
            UpdateAllViews(NULL);
			setridOST(0,m_zarazkaOST-1);
  		    SetModifiedFlag();
			this->defchanged(true); //change in definition code removed
			return;
		}
        delete poleOST[pozice]; //pokud neni na konci
		for (i=pozice;i<(UINT)(m_zarazkaOST-1);i++){
			poleOST[i]=poleOST[i+1];
		}
		m_zarazkaOST--;
		AfxMessageBox("kd vymazn!",MB_OK|MB_ICONSTOP,0);
        UpdateAllViews(NULL);
		if (m_zarazkaOST>1)setridOST(0,m_zarazkaOST-1);
		SetModifiedFlag();
		this->defchanged(true); //change in definition code removed
		return;
	}
	else 
	 AfxMessageBox("kd nenalezen!",MB_OK|MB_ICONSTOP,0);
}

void CVykazy1Doc::OnPolAktual()  //save definition into the file
{
 // TODO: Add your command handler code here
 char* pszFileName = "definice2.txt";
 FILE* myfile;
 FILE* titlefile;

 if((myfile=fopen(pszFileName,"wt"))==NULL)
 {
      AfxMessageBox("Nemohu otevt soubor definice2.txt pro aktualizaci!!",
  		            MB_OK|MB_ICONSTOP,0 );
	return;
 }
 
 fprintf(myfile,"//SOUBOR definic pro program vykazy\n");
 fprintf(myfile,"//velikost radku je maximalne 256 znaku\n\n");
 
 fprintf(myfile,"STANDART\n");
 for(int i=0;i<m_zarazkaST;i++){
  fprintf(myfile,"%d\n",poleST[i]->dejkod());
  fprintf(myfile,"%s\n",poleST[i]->nazev);
  fprintf(myfile,"%.2f\n",poleST[i]->cena);
 }
 fprintf(myfile,"KONECST\n\n");

 fprintf(myfile,"PROTETIKA\n");
 for(i=0;i<m_zarazkaPR;i++){
  fprintf(myfile,"%d\n",polePR[i]->dejkod());
  fprintf(myfile,"%s\n",polePR[i]->nazev);
  fprintf(myfile,"%.2f\n",polePR[i]->cena);
 }
 fprintf(myfile,"KONECPR\n\n");
 
 fprintf(myfile,"OSTATNI\n");
 for(i=0;i<m_zarazkaOST;i++){
  fprintf(myfile,"%d\n",poleOST[i]->dejkod());
  fprintf(myfile,"%s\n",poleOST[i]->nazev);
  fprintf(myfile,"%.2f\n",poleOST[i]->cena);
 }
 fprintf(myfile,"KONECKV\n\n");
 fprintf(myfile,"END DEFFILE\n\n");
 fclose(myfile);

#ifdef XML_out

 pszFileName = "definice.xml";
 if((myfile=fopen(pszFileName,"wt"))==NULL)
 {
      AfxMessageBox("Nemohu otevt soubor definice2.xml pro aktualizaci!!",
  		            MB_OK|MB_ICONSTOP,0 );
	return;
 }

 //for titles def., which are in WIN-1250 code and 
 //xml file with definitions must be in UTF-8, becuase of parser  
 pszFileName = "titles.def";
 if((titlefile=fopen(pszFileName,"wt"))==NULL)
 {
      AfxMessageBox("Nemohu otevt soubor titles.def!!",
  		            MB_OK|MB_ICONSTOP,0 );
	return;
 }
 
 fprintf(myfile,"<?xml version=\"1.0\"?>\n");
 fprintf(myfile,"<!-- SOUBOR definic pro program vykazy -->\n");
 fprintf(myfile,"<Vykaz names=\"titles.def\">\n");
 fprintf(myfile,"<STANDARD>\n");
 for(i=0;i<m_zarazkaST;i++){
  fprintf(myfile,"<item title=\"%d\">\n",i);
  fprintf(titlefile,"%s\n",poleST[i]->nazev);
  fprintf(myfile,"  <code>%d</code>\n",poleST[i]->dejkod());
  fprintf(myfile,"  <charge>%.2f</charge>\n",poleST[i]->cena);
  fprintf(myfile," </item>\n");
 }
 fprintf(myfile,"</STANDARD>\n\n");
 
 fprintf(myfile,"<PROTETIK>\n");
 for(i=0;i<m_zarazkaPR;i++){
  fprintf(myfile,"<item title=\"%d\">\n",m_zarazkaST+i);
  fprintf(titlefile,"%s\n",polePR[i]->nazev);
  fprintf(myfile,"  <code>%d</code>\n",polePR[i]->dejkod());
  fprintf(myfile,"  <charge>%.2f</charge>\n",polePR[i]->cena);
  fprintf(myfile," </item>\n");
 }
 fprintf(myfile,"</PROTETIK>\n\n");

 fprintf(myfile,"<OTHERS>\n");
 for(i=0;i<m_zarazkaOST;i++){
  fprintf(myfile,"<item title=\"%d\">\n",m_zarazkaST+m_zarazkaPR+i);
  fprintf(titlefile,"%s\n",poleOST[i]->nazev);
  fprintf(myfile,"  <code>%d</code>\n",poleOST[i]->dejkod());
  fprintf(myfile,"  <charge>%.2f</charge>\n",poleOST[i]->cena);
  fprintf(myfile," </item>\n");
 }
 fprintf(myfile,"</OTHERS>\n");

 fprintf(myfile,"</Vykaz>\n");
 fclose(myfile);
 fclose(titlefile);
#endif
//end XML def saving
 defchanged(false);
}

void CVykazy1Doc::defchanged(bool status)
{
 changedef=status; 
}


void CVykazy1Doc::startXMLelm(void *data, const char *el, const char **attr){
CString pom;
int nmb,i;
int poc=0;
char retez[256];
char *retez2;
 
 if (XMLerr) return;

 if(strcmp(el,"Vykaz")==0){
  pom=*(attr+1);
  if((aktdoc->titlefile=fopen(pom,"rt"))==NULL)
  {
   AfxMessageBox( "Nemohu otevt soubor s nzvy kd!",
   		            MB_OK|MB_ICONSTOP,0 );
   XMLerr=true;
   return;
  }
 }

 if(strcmp(el,"STANDARD")==0){
  aktdoc->section="ST";
 }

 if(strcmp(el,"PROTETIK")==0){
  aktdoc->section="PR";
 }

 if(strcmp(el,"OTHERS")==0){
  aktdoc->section="OT";
 }

 if(strcmp(el,"item")==0){
  if(strcmp(aktdoc->section,"ST")==0){
   aktdoc->poleST[aktdoc->m_zarazkaST]= new Ckodpol();
   pom=*(attr+1);
   nmb=atoi(pom);
   i=0;
   fseek(aktdoc->titlefile,0, SEEK_SET);
   while (i++<=nmb) {
    fgets(retez,256,aktdoc->titlefile);
   }
   poc=strlen(retez);
   retez2=(char*)malloc(poc);
   memset(retez2,0,poc);
   strncpy(retez2,retez,poc-1);
   aktdoc->poleST[aktdoc->m_zarazkaST]->nazev=retez2;
   free(retez2);
  }
  
  if(strcmp(aktdoc->section,"PR")==0){
   aktdoc->polePR[aktdoc->m_zarazkaPR]= new Ckodpol();
   pom=*(attr+1);
   nmb=atoi(pom);
   i=0;
   fseek(aktdoc->titlefile,0, SEEK_SET);
   while (i++<=nmb) {
    fgets(retez,256,aktdoc->titlefile);
   }
   poc=strlen(retez);
   retez2=(char*)malloc(poc);
   memset(retez2,0,poc);
   strncpy(retez2,retez,poc-1);
   aktdoc->polePR[aktdoc->m_zarazkaPR]->nazev=retez2;
   free(retez2);
  }

  if(strcmp(aktdoc->section,"OT")==0){
   aktdoc->poleOST[aktdoc->m_zarazkaOST]= new Ckodpol();
   pom=*(attr+1);
   nmb=atoi(pom);
   i=0;
   fseek(aktdoc->titlefile,0, SEEK_SET);
   while (i++<=nmb) {
    fgets(retez,256,aktdoc->titlefile);
   }
   poc=strlen(retez);
   retez2=(char*)malloc(poc);
   memset(retez2,0,poc);
   strncpy(retez2,retez,poc-1);
   aktdoc->poleOST[aktdoc->m_zarazkaOST]->nazev=retez2;
   free(retez2);
  }
 }

 if(strcmp(el,"code")==0){
  aktdoc->sectionItem="code";
 }

 if(strcmp(el,"charge")==0){
  aktdoc->sectionItem="charge";
 }
  
}

void CVykazy1Doc::endXMLelm(void *data, const char *el){

 if (XMLerr) return;

 if(strcmp(el,"code")==0){
  aktdoc->sectionItem="";
 }
 if(strcmp(el,"charge")==0){
  aktdoc->sectionItem="";
 }
 if(strcmp(el,"item")==0){
  if(strcmp(aktdoc->section,"ST")==0){
  	 aktdoc->poleST[aktdoc->m_zarazkaST]->pocetInt=0;
     aktdoc->m_zarazkaST++;
  }
  if(strcmp(aktdoc->section,"PR")==0){
  	 aktdoc->polePR[aktdoc->m_zarazkaPR]->pocetInt=0;
     aktdoc->m_zarazkaPR++;
  }
  if(strcmp(aktdoc->section,"OT")==0){
  	 aktdoc->poleOST[aktdoc->m_zarazkaOST]->pocetFloat=0;
     aktdoc->m_zarazkaOST++;
  }
 }
 
 if(strcmp(el,"STANDARD")==0){
  aktdoc->section="";
 }

 if(strcmp(el,"PROTETIK")==0){
  aktdoc->section="";
 }

 if(strcmp(el,"OTHERS")==0){
  aktdoc->section="";
 }

 if(strcmp(el,"Vykaz")==0){
  fclose(aktdoc->titlefile);
 }

}

void CVykazy1Doc::texthnd(void *data,const char *text,int len){
char* pom;

if (XMLerr) return;

 if (strcmp(aktdoc->section,"ST")==0) {
  if(strcmp(aktdoc->sectionItem,"code")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->poleST[aktdoc->m_zarazkaST]->nastavkod(atoi(pom));
  delete pom;
  }
  if(strcmp(aktdoc->sectionItem,"charge")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->poleST[aktdoc->m_zarazkaST]->cena=(float)atof(pom);
  delete pom;
  }
 }

 if (strcmp(aktdoc->section,"PR")==0) {
  if(strcmp(aktdoc->sectionItem,"code")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->polePR[aktdoc->m_zarazkaPR]->nastavkod(atoi(pom));
  delete pom;
  }
  if(strcmp(aktdoc->sectionItem,"charge")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->polePR[aktdoc->m_zarazkaPR]->cena=(float)atof(pom);
  delete pom;
  }
 }

 if (strcmp(aktdoc->section,"OT")==0) {
  if(strcmp(aktdoc->sectionItem,"code")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->poleOST[aktdoc->m_zarazkaOST]->nastavkod(atoi(pom));
  delete pom;
  }
  if(strcmp(aktdoc->sectionItem,"charge")==0){
  pom=new char[len+1];
  memset(pom,0,len+1);
  strncpy((char*)pom,text,len);
  aktdoc->poleOST[aktdoc->m_zarazkaOST]->cena=(float)atof(pom);
  delete pom;
  }
 }

}

void CVykazy1Doc::OnUpdatePolAktual(CCmdUI* pCmdUI) 
{
  // TODO: Add your command update UI handler code here
  if (!changedef)
     pCmdUI->Enable(false);
}

int CVykazy1Doc::loadfromXML()
{
 char* pszFileName = "definice.xml";
 FILE* myfile;
 char Buff[BUFFSIZE];

 aktdoc=this;
 if((myfile=fopen(pszFileName,"rt"))==NULL)
 {
      AfxMessageBox( "Nemohu otevt soubor definice2.xml",
  		            MB_OK|MB_ICONSTOP,0 );
	return 0;
 }

 
 XML_Parser p = XML_ParserCreate(NULL);
 if (! p) {
   AfxMessageBox("Nen pamt pro alokaci XML parseru!",MB_OK|MB_ICONSTOP,0);
   return 0;
  }

 XML_SetStartElementHandler(p,startXMLelm);
 XML_SetEndElementHandler(p,endXMLelm);
 XML_SetCharacterDataHandler(p,texthnd);

 for (;;) {
  int done;
  int len;

  len = fread(Buff, 1, BUFFSIZE, myfile);
  if (ferror(myfile)) {
   AfxMessageBox("Chyba pi ten ze souboru definice2.xml!",MB_OK|MB_ICONSTOP,0);
   return 0;      
  }
  done = feof(myfile);

  if (!XML_Parse(p, Buff, len, done)) {
    char message[50];
	sprintf(message,"Parse error at line %d:\n%s\n",
	      XML_GetCurrentLineNumber(p),
	      XML_ErrorString(XML_GetErrorCode(p)));
   	AfxMessageBox(message,MB_OK|MB_ICONSTOP,0);
    return 0;      
  }

  if(done)break;
 }
 fclose(myfile);
 return 1;
}

